function [ dx ] = state( t, x, w, ks, ndisc, ModelData )
 % State system
%dx=statesens(t,x,w,ks,ModelData); for later with sensitivity
dx=zeros(ModelData.numstates+1,1);%column of state variables plus cost variable
    bc = interp1qr(ModelData.PowerConditions(:,1),ModelData.PowerConditions(:,2),t);

    xPWO=bc;
    ubattin=w(ks,1)*ModelData.ControlScales;
    ubattout=w(ks+1*ndisc,1)*ModelData.ControlScales;
    
    xPWO=xPWO-ubattin+ubattout;
    dx(1) = ubattin*ModelData.cBattEfficiency-ubattout - ModelData.cBattSigma*x(1);  %x1' ; for battery
    
    ufcin=w(ks+2*ndisc,1)*ModelData.ControlScales;
    ufcout=w(ks+3*ndisc,1)*ModelData.ControlScales;
    
    %if (ufcin>=0) %into h2; = ucell    "one empirical model" - electrolyzer
        xPWO=xPWO-ufcin*(ModelData.ElecVrev+(ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(ufcin/ModelData.ElecA)+...
          (ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*...
          log(1+(ufcin/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2)));
      dx(2) = ModelData.ElecNumCells*ufcin*ModelData.ElecFefficiency;
    %end
    %if (ufcout>=0)      % - Fuelcell .. the parameter is in this case the CURRENT
        %produced power:...............ufc is the same current through all
        %the cells
        areacurrent=(ufcout/ModelData.CellA);%inside the cell
        xPWO=xPWO+ModelData.CellNumCell*ufcout*(ModelData.CellVrev+ModelData.CellB*log(ModelData.Celli0)-...
            ModelData.CellAt*log(areacurrent)-areacurrent*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll));
        %eaten hydrogen in units of H2 times n_e times FaradayCOnstant:
      dx(2) = dx(2)+ ufcout*ModelData.CellNumCell*ModelData.CellFInvefficiency;
    %end
      
    if (xPWO>=0)
        dx(3)=xPWO*ModelData.cSellPower;
    else
        dx(3)=xPWO*ModelData.cBuyPower;
    end

end