function [ dx ] = state( t, x, w, ks, ndisc, ModelData )
 % State system
%dx=statesens(t,x,w,ks,ModelData); for later with sensitivity
dx=zeros(ModelData.numstates+1,1);%column of state variables plus cost variable
    bc = interp1qr(ModelData.PowerConditions(:,1),ModelData.PowerConditions(:,2),t);

    xPWO=bc;
    ubatt=w(ks,1)*ModelData.ControlScales;
    if (ubatt>=0) %into batt; % w(ks,1) = ubatt
        xPWO=xPWO-ubatt;
        dx(1) = ubatt*ModelData.cBattEfficiency - ModelData.cBattSigma*x(1);  %x1' ; for battery
    else
        xPWO=xPWO-ubatt;
        dx(1) = ubatt - ModelData.cBattSigma*x(1);
    end
    
    ufc=w(ks+1*ndisc,1)*ModelData.ControlScales;
    
    if (ufc>=0) %into h2; w(ks,2) = ucell    "one empirical model" - electrolyzer
        xPWO=xPWO-ufc*(ModelData.ElecVrev+(ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(ufc/ModelData.ElecA)+...
          (ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*...
          log(1+(ufc/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2)));
      dx(2) = ModelData.ElecNumCells*ufc*ModelData.ElecFefficiency;
    else      % - Fuelcell .. the parameter w(ks,2) is in this case the CURRENT
        %produced power:...............ufc is the same current through all
        %the cells
        areacurrent=(-ufc/ModelData.CellA);%inside the cell
        xPWO=xPWO-ModelData.CellNumCell*ufc*(ModelData.CellVrev+ModelData.CellB*log(ModelData.Celli0)-...
            ModelData.CellAt*log(areacurrent)-areacurrent*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll));
        %eaten hydrogen in units of H2 times n_e times FaradayCOnstant:
      dx(2) = ufc*ModelData.CellNumCell*ModelData.CellFInvefficiency *(1.0/(1.0+0.3*sqrt(w(ModelData.numcontrols*ndisc+ModelData.numstates*(ndisc-1),1)/ModelData.hicost)));
    end
      
    if (xPWO>=0)
        dx(3)=xPWO*ModelData.cSellPower;
    else
        dx(3)=xPWO*ModelData.cBuyPower;
    end

end