clear all;
clf;
format long;
consts;

 % Options for NLP Solvers
 optODE = odeset( 'RelTol', 1e-8, 'AbsTol', 1e-8 );
 optNLP = optimset( 'LargeScale', 'off', 'GradObj', 'off', 'GradConstr', 'off',...
 'DerivativeCheck', 'off', 'Display', 'iter', 'TolX', 1e-9,...
 'TolFun', 1e-9, 'TolCon', 1e-9, 'MaxFunEval', 600,...
 'DiffMinChange', 1e-5 );
%'GradObj','on','DerivativeCheck','on','HessUpdate','bfgs','Diagnostic','on','LineSearchType','cubicpoly',
%GradConstr on
 % Time Horizon and Initial State
 %Data.t_start; % Initial time
 %Data.t_end; % Final time
 x0 = [ Data.Wbattinit; 0; 0 ]; % Initial state (state1,state2,cost) = (battery,cell,cost)

 ns = 2^(Data.cLogBegin-1);
 numcontrols=2;
 w0 = zeros(ns,numcontrols);
 for is = Data.cLogBegin:Data.cLogEnd
 ns = 2*ns; % Number of stages: ns = 2, 4, 8, 16, and 32
 ts = [Data.t_start:(Data.t_end-Data.t_start)/ns:Data.t_end]; % Time stages (equipartition)

 % Initial Guess and Bounds for the Parameters
 wold=w0;
 w0 = zeros(ns,numcontrols);
 for (inumcontrols=1:numcontrols)
    for (jsi=1:ns)%use previous results as initial guess.
         w0(jsi,inumcontrols) = wold(1+floor((jsi-1)/2),inumcontrols);
    end
 end    
 
 wL = Data.Pbattminusmax*ones(ns,numcontrols); %parameter (=control) bounds in each tie stage
 wU = Data.Pbattplusmax*ones(ns,numcontrols);
 wL(:,2)=Data.Ph2minusmax*ones(ns,1);
 wU(:,2)=Data.Ph2plusmax*ones(ns,1); 

 % Sequential Approach of Dynamic Optimization
 %fminsearch - todo
 [ wopt ] = fmincon( @(ws)obj(x0,ns,ts,ws,Data), w0, [], [], [], [], wL, wU,...
 @(ws)ctr(x0,ns,ts,ws,Data), optNLP);
 dispopt( x0, ns, ts, wopt,Data, optODE );
 dlmwrite('controldata',wopt);

end