function [ f,allvalues ] = fun( x0, ns, ts, ws,ModelData )

 % Options for ODE solver
 optODE = odeset( 'RelTol', 1e-8, 'AbsTol', 1e-8 );

 allvalues=zeros(ns,ModelData.numstates);
 
 % Forward state integration
 z0 = [ x0 ];
 allvalues(1,:)=z0(1:ModelData.numstates);%row vect
 %checking of constraints...
 for ks = 1:ns
 [tspan,zs] = ode15s( @(t,x)state(t,x,ws,ks,ModelData), [ts(ks),ts(ks+1)], z0, optODE );
 %for single shooting, we continue where we ended last time interval
 %z0 = zs(end,:)'; %vratilo sloupcovej vektor, do z0 udelame radek 
 %for multiple shooting, we have variable for the begining:
 if (ks<ns) %but not for the last stage, we set it only for
 for i=1:(ModelData.numstates)
    z0(i,1)=ws((ModelData.numcontrols*ModelData.currentns)+(i-1)*(ModelData.currentns-1)+ks,1);  
 z0(ModelData.numstates+1)=zs(end,end);%we just add the cost, no multipleshooting for cost
 end
 
 allvalues(ks+1,:)=zs(end,1:ModelData.numstates);%ptze +1 je cost function a tu nemusime rikat.
 %if (ks==1)
 %   largest=max(zs)';
 %   smallest=min(zs)';
 %else
 %   largest=max([largest,zs']')';
 %   smallest=min([smallest,zs']')';
 %end
 end
 % Functions
 f = zs(end,:)';
 %f = [f,largest,smallest];

end