function [ dx ] = state( t, x, w, ks,ModelData )
 % State system
% dx=[ x(2) + w(ks);
% - w(ks);
% x(1)^2 / 2.+ModelData.cSellPower ];
dx=zeros(3,1);%row
bc = interp1qr(ModelData.PowerConditions(:,1),ModelData.PowerConditions(:,2),t);
%bc=sin(t);% ((ACADO::Curve*)userData)->evaluate(t,&bc);

if (ModelData.SimpleTest==1)
    if (w(ks,1)>=0) %into batt; % w(ks,1) = ubatt
      dx(1) = w(ks,1)*ModelData.cBattEfficiency - ModelData.cBattSigma*x(1);  %x1' ; for battery
    else
      dx(1) = w(ks,1) - ModelData.cBattSigma*x(1);
    end
    if (w(ks,2)>=0) %into cell; w(ks,2) = ucell
      dx(2) = w(ks,2)*ModelData.cH2Efficiency;  %x2' ; for hydrogen
    else
      dx(2) = w(ks,2);
    end
      
    xPWO=bc-w(ks,1)-w(ks,2); %power out
    if (xPWO>=0)
        dx(3)=xPWO*ModelData.cSellPower;
    else
        dx(3)=xPWO*ModelData.cBuyPower;
    end
else
    xPWO=bc;
    if (w(ks,1)>=0) %into batt; % w(ks,1) = ubatt
        xPWO=xPWO-w(ks,1);
        dx(1) = w(ks,1)*ModelData.cBattEfficiency - ModelData.cBattSigma*x(1);  %x1' ; for battery
    else
        xPWO=xPWO-w(ks,1);
        dx(1) = w(ks,1) - ModelData.cBattSigma*x(1);
    end
    
    if (w(ks,2)>=0) %into h2; w(ks,2) = ucell    "one empirical model" - electrolyzer
        xPWO=xPWO-w(ks,2)*(ModelData.ElecVrev+(ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(w(ks,2)/ModelData.ElecA)+...
          (ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*...
          log(1+(w(ks,2)/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2)));
      dx(2) = ModelData.ElecNumCell*w(ks,2)*ModelData.ElecFefficiency;
    else      % - Fuelcell .. the parameter w(ks,2) is in this case the CURRENT
        %produced power:
        areacurrent=(-w(ks,2)/ModelData.CellA)/ModelData.CellNumCell;%inside the cell
        xPWO=xPWO-w(ks,2)*(ModelData.CellVrev+ModelData.B*log(ModelData.Celli0)-...
            ModelData.CellAt*log(areacurrent)-areacurrent*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll));
        %eaten hydrogen in units of H2 times n_e times FaradayCOnstant:
      dx(2) = w(ks,2)*ModelData.CellNumCell*Data.CellFInvefficiency;
    end
      
    if (xPWO>=0)
        dx(3)=xPWO*ModelData.cSellPower;
    else
        dx(3)=xPWO*ModelData.cBuyPower;
    end
end

end