function dispopt( x0, ts, ws,ModelData, optODE, iter )
ndisc=size(ts,2)-1;%ts is row vector
% Forward state integration; store optimal state & control
z0 = [ x0 ];
topt = [];
xopt = [];
uopt = [];
for ks = 1:ndisc
   [tspan,zs] = ode15s( @(t,x)state(t,x,ws,ks,ndisc,ModelData), [ts(ks),ts(ks+1)], z0, optODE );
  % if iter<0 %last image, lets say we do wverything continually
  %     z0 = zs(end,:)';
  % else %display how multipleshooting works
       if (ks<ndisc) %but not for the last stage, we set it only for
            for i=1:(ModelData.numstates)
                z0(i,1)=ws((ModelData.numcontrols*ndisc)+(i-1)*(ndisc-1)+ks,1); 
            end
            z0(ModelData.numstates+1,1)=zs(end,ModelData.numstates+1);%we just add the cost, no multipleshooting for cost
        end
   %end
   topt = [ topt; tspan ];
   xopt = [ xopt; zs ];
   uopt = [ uopt; [ws(ks)*ones(length(tspan),1),ws(ndisc+ks)*ones(length(tspan),1)] ];
   %bc=interp1qr(ModelData.PowerConditions(:,1),ModelData.PowerConditions(:,2),tspan);
end

if (iter<0)
% Display Optimal Cost
J=-obj( x0, ts, ws,ModelData );
disp(sprintf('Optimal cost for ns=%d: %d', ndisc, J));

[c,ceq]=ctr( x0, ts, ws,ModelData );
zk=max(abs(ceq));
disp(sprintf('Max constraint violation ns=%d: %d', ndisc, zk));

end

% Plot results
hfig = figure(1);
set(hfig, 'Position', [0 0 1000 1000]);

subplot(2,2,1) 
plot(topt,xopt(:,1),'r',topt,xopt(:,2),'b')
xlabel('t [hours]')
ylabel({'x1(t) (red) bettery charge [J],';'x2(t) (blue) stored hydrogen [mol*2*F]'})
title(['States ns=',int2str(ndisc)])
%saveas(gcf,['x1(t)_x2(t)_',int2str(ndisc),'stg.eps'], 'psc2')
 
subplot(2,2,2) 
plot(topt,xopt(:,ModelData.numstates+1))
xlabel('t [hours]')
ylabel('cost(t) [virtual currency]')
title(['TermCost ns=',int2str(ndisc)])
 
subplot(2,2,3) 
plot(topt,uopt(:,1),'r',topt,uopt(:,2),'b')
xlabel('t [hours]')
ylabel({'u1(t) (red), power to/from battery [100*W],';' u2(t) (blue) current/hydrogen [100*2*F*A]'})
title(['ControlF ns=',int2str(ndisc)])
 
subplot(2,2,4) 
plot(xopt(:,1),xopt(:,2),'r')
xlabel('x1(t) battery charge [J]')
ylabel('x2(t) stored hydrogen [mol*2*F]')
title(['StateTraj ns=',int2str(ndisc)])
 
 
%figure(2)
%plot(xopt(:,1),xopt(:,2),'r')
%xlabel('x1(t)')
%ylabel('x2(t)')
%title(['ns=',int2str(ndisc)])
%saveas(gcf,['x2(x1)_',int2str(ndisc),'stg.eps'], 'psc2')

%figure(3)
%%plot(topt,uopt(:,1),'r',topt,uopt(:,2),'b')
%plot(topt,uopt,'r')
%xlabel('t')
%%ylabel('u1(t), u2(t)')
%ylabel('u(t)')
%title(['ns=',int2str(ns)])
%saveas(gcf,['u(t)_',int2str(ns),'stg.eps'], 'psc2')

dlmwrite(sprintf('controldataiter%d',iter),ws);

if (iter<0)
    print('matepsfig','-depsc2','-r300');
end

end

