function [ f,allvalues ] = fun( x0, ts, ws,ModelData )
ndisc=size(ts,2)-1;%ts is row vector

 % Options for ODE solver
 optODE = odeset( 'RelTol', 1e-8, 'AbsTol', 1e-8 );

 allvalues=zeros(ndisc,ModelData.numstates);
 
 % Forward state integration
 z0 = [ x0 ];%column vector
 allvalues(1,:)=z0(1:ModelData.numstates,1)';%results will be layered as rows to one big numstates-column matrix
 %checking of constraints...
 lastwarn('', '');
 for ks = 1:ndisc
    [tspan,zs] = ode15s( @(t,x)state(t,x,ws,ks,ndisc,ModelData), [ts(ks),ts(ks+1)], z0, optODE );
    if (lastwarn)
        dlmwrite('errored-controls.txt',ws);
        dlmwrite('errored-ks.txt',ks);
        error(lastwarn)
    end
    %for single shooting, we continue where we ended last time interval
    %z0 = zs(end,:)'; %vratilo sloupcovej vektor, do z0 udelame radek 
    %for multiple shooting, we have variable for the begining:
    if (ks<ndisc) %but not for the last stage, we set it only for
        for i=1:(ModelData.numstates)
            z0(i,1)=ws((ModelData.numcontrols*ndisc)+(i-1)*(ndisc-1)+ks,1); 
        end
        z0(ModelData.numstates+1,1)=zs(end,end);%we just add the cost, no multipleshooting for cost
    end
 
    allvalues(ks+1,:)=zs(end,1:ModelData.numstates);%ptze +1 je cost function a tu nemusime rikat. Also zs is returned as rows
    %if (ks==1)
    %   largest=max(zs)';
    %   smallest=min(zs)';
    %else
    %   largest=max([largest,zs']')';
    %   smallest=min([smallest,zs']')';
    %end
 end
 % Functions
 f = zs(end,:)';
 %f = [f,largest,smallest];

end