function [ dx,ddx ] = statesens( t, x, w, ks, ndisc,ModelData )
%STATESENS Summary of this function goes here
%   Detailed explanation goes here

% state:
    dx=zeros(ModelData.numstates+1,1);%column of state variables plus cost variable
    bc = interp1qr(ModelData.PowerConditions(:,1),ModelData.PowerConditions(:,2),t);

    xPWO=bc;
    ubatt=w(ks,1)*ModelData.ControlScales;
    if (ubatt>=0) %into batt; % w(ks,1) = ubatt
        xPWO=xPWO-ubatt;
        dx(1) = ubatt*ModelData.cBattEfficiency - ModelData.cBattSigma*x(1);  %x1' ; for battery     
    else
        xPWO=xPWO-ubatt;
        dx(1) = ubatt - ModelData.cBattSigma*x(1);
    end
    
    ufc=w(ks+1*ndisc,1)*ModelData.ControlScales;
    
    if (ufc>=0) %into h2; w(ks,2) = ucell    "one empirical model" - electrolyzer
        xPWO=xPWO-ufc*(ModelData.ElecVrev+(ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(ufc/ModelData.ElecA)+...
          (ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*...
          log(1+(ufc/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2)));
      dx(2) = ModelData.ElecNumCells*ufc*ModelData.ElecFefficiency;
    else      % - Fuelcell .. the parameter w(ks,2) is in this case the CURRENT
        %produced power:
        areacurrent=(-ufc/ModelData.CellA)/ModelData.CellNumCell;%inside the cell
        xPWO=xPWO-ufc*(ModelData.CellVrev+ModelData.CellB*log(ModelData.Celli0)-...
            ModelData.CellAt*log(areacurrent)-areacurrent*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll));
        %eaten hydrogen in units of H2 times n_e times FaradayCOnstant:
      dx(2) = ufc*ModelData.CellNumCell*ModelData.CellFInvefficiency;
    end
      
    if (xPWO>=0)
        dx(3)=xPWO*ModelData.cSellPower;
    else
        dx(3)=xPWO*ModelData.cBuyPower;
    end

if nargout == 2%state and sensitivity equations
    %compute sensitivity for each scalar of function depending on each
    %control value. Number of control values is ns.
    %what to do with control values of multiple shooting?
    
     % Append sensitivity system
     ddx=[];
     curr=[];
     inndifs=ModelData.numstates+1;%plus 1 for the state equation for integrating cost
     derdx=zeros(inndifs,1);
     %for all the controls and for all the stages
    for currc = 1:ModelData.numcontrols%je toto ve spravnym poradi jako se indexuje?
        for is = 1:ndisc
            uws = zeros(ModelData.numcontrols);
    
    
            if is == ks
                uws(currc) = 1.0;
            end % a tady se mzkoncil a jak dal hm? 
    
            indexstate1=inndifs*is+1;
            indexstate2=inndifs*is+2;    
            indexstate3=inndifs*is+3;
        
            %how to derivate statesensitivity:
            %if you see a control function, derivate. If you see a state,
            %derivate it and multiply by sensitivity state for the variable.
            %%ddx(1)=uws*ModelData.cBattEfficiency-ModelData.cBattSigma*x(is+1)
            
            ubattder=uws(1)*ModelData.ControlScales;
            xPWOder=0;%derivation of boundary conditions is zero (with respect to control function I mean)
            if (ubatt>=0) %into batt; % w(ks,1) = ubatt
                xPWOder=xPWOder-ubattder;
                derdx(1) = ubattder*ModelData.cBattEfficiency - ModelData.cBattSigma*x(indexstate1);     
            else
                xPWOder=xPWOder-ubattder;
                derdx(1) = ubattder - ModelData.cBattSigma*x(indexstate1);
            end
       
            ufcder=uws(2)*ModelData.ControlScales;
    
            if (ufc>=0) %into h2; w(ks,2) = ucell    "one empirical model" - electrolyzer
                %derivating this:
                %xPWO=xPWO-ufc*(ModelData.ElecVrev+(ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(ufc/ModelData.ElecA)+...
                %(ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*...
                %log(1+(ufc/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2)));
                xPWOder=xPWOder-...
                    (ufcder*(ModelData.ElecVrev+(ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(ufc/ModelData.ElecA)+(ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*log(1+(ufc/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2)))...
                    +ufc*(   (ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(ufcder/ModelData.ElecA)+(ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*1/(1+(ufcder/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2))     )    );
                
                derdx(2) = ModelData.ElecNumCells*ufcder*ModelData.ElecFefficiency;
            else      % - Fuelcell .. the parameter w(ks,2) is in this case the CURRENT
                %produced power:
                areacurrent=(-ufc/ModelData.CellA)/ModelData.CellNumCell;%inside the cell
                areacurrentder=(-ufcder/ModelData.CellA)/ModelData.CellNumCell;%inside the cell
                %derivative of this:
                %xPWO=xPWO-ufc*(ModelData.CellVrev+ModelData.CellB*log(ModelData.Celli0)-...
                %ModelData.CellAt*log(areacurrent)-areacurrent*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll));
                xPWOder=xPWOder-...
                    (ufcder*(ModelData.CellVrev+ModelData.CellB*log(ModelData.Celli0)-ModelData.CellAt*log(areacurrent)-areacurrent*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll))...
                    +ufc*(-ModelData.CellAt*1/(areacurrentder)-areacurrentder*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll)*areacurrentder*ModelData.Celll)    );
                %eaten hydrogen in units of H2 times n_e times FaradayCOnstant:
                derdx(2) = ufcder*ModelData.CellNumCell*ModelData.CellFInvefficiency;
            end
      
            if (xPWOder>=0)
                derdx(3)=xPWOder*ModelData.cSellPower;
            else
                derdx(3)=xPWOder*ModelData.cBuyPower;
            end
        
        
            curr=[curr;derdx];%stick together. just to one big column.
        end
    end
end

 ddx = [ curr];

end
