function [ dx ] = state( t, x, w, ks, ndisc, ModelData )
 % State system
%dx=statesens(t,x,w,ks,ModelData); for later with sensitivity

    dx=zeros(ModelData.numstates+1,1);%column of state variables plus cost variable
    bc = interp1qr(ModelData.PowerConditions(:,1),ModelData.PowerConditions(:,2),t);

    xPWO=bc;
    ubatt=w(ks,1)*ModelData.ControlScales;
    if (ubatt>=0) %into batt; % w(ks,1) = ubatt
        xPWO=xPWO-ubatt;
        dx(1) = ubatt*ModelData.cBattEfficiency - ModelData.cBattSigma*x(1);  %x1' ; for battery
    else
        xPWO=xPWO-ubatt;
        dx(1) = ubatt - ModelData.cBattSigma*x(1);
    end
    
    ufc=w(ks+1*ndisc,1)*ModelData.ControlScales;
    
    %specialne zmeneno na vyzkouseni dvoudimenzionalni controlfunkce:
    if (ufc>=0) %into h2; w(ks,2) = ucell    "one empirical model" - electrolyzer
        xPWO=xPWO-ufc;
        dx(2) = ufc*ModelData.ElecFefficiency - ModelData.cBattSigma*x(2);
    else      % - Fuelcell .. the parameter w(ks,2) is in this case the CURRENT
         xPWO=xPWO-ufc;
        %eaten hydrogen in units of H2 times n_e times FaradayCOnstant:
      dx(2) = ufc - ModelData.cBattSigma*x(2);
    end
      
    if (xPWO>=0)
        dx(3)=xPWO*ModelData.cSellPower;
    else
        dx(3)=xPWO*ModelData.cBuyPower;
    end

end