function [ dx,ddx ] = statesens( t, x, w, ks,ModelData )
%STATESENS Summary of this function goes here
%   Detailed explanation goes here

% state:
    dx=zeros(ModelData.numstates+1,1);%column of state variables plus cost variable
    bc = interp1qr(ModelData.PowerConditions(:,1),ModelData.PowerConditions(:,2),t);

    xPWO=bc;
    ubatt=w(ks,1)*ModelData.ControlScales;
    if (ubatt>=0) %into batt; % w(ks,1) = ubatt
        xPWO=xPWO-ubatt;
        dx(1) = ubatt*ModelData.cBattEfficiency - ModelData.cBattSigma*x(1);  %x1' ; for battery
    else
        xPWO=xPWO-ubatt;
        dx(1) = ubatt - ModelData.cBattSigma*x(1);
    end
    
    ufc=w(ks+1*ModelData.currentns,1)*ModelData.ControlScales;
    
    if (ufc>=0) %into h2; w(ks,2) = ucell    "one empirical model" - electrolyzer
        xPWO=xPWO-ufc*(ModelData.ElecVrev+(ModelData.Elecr1+ModelData.Elecr2*ModelData.ElecTemp)*(ufc/ModelData.ElecA)+...
          (ModelData.Elecs1+ModelData.Elecs2*ModelData.ElecTemp+ModelData.Elecs3*ModelData.ElecTemp^2)*...
          log(1+(ufc/ModelData.ElecA)*(ModelData.Elect1+ModelData.Elect2*ModelData.ElecTemp+ModelData.Elect3*ModelData.ElecTemp^2)));
      dx(2) = ModelData.ElecNumCells*ufc*ModelData.ElecFefficiency;
    else      % - Fuelcell .. the parameter w(ks,2) is in this case the CURRENT
        %produced power:
        areacurrent=(-ufc/ModelData.CellA)/ModelData.CellNumCell;%inside the cell
        xPWO=xPWO-ufc*(ModelData.CellVrev+ModelData.CellB*log(ModelData.Celli0)-...
            ModelData.CellAt*log(areacurrent)-areacurrent*ModelData.Cellr+ModelData.Cellm*exp(areacurrent*ModelData.Celll));
        %eaten hydrogen in units of H2 times n_e times FaradayCOnstant:
      dx(2) = ufc*ModelData.CellNumCell*ModelData.CellFInvefficiency;
    end
      
    if (xPWO>=0)
        dx(3)=xPWO*ModelData.cSellPower;
    else
        dx(3)=xPWO*ModelData.cBuyPower;
    end

if nargout == 2%state and sensitivity equations
    %compute sensitivity for each scalar of function depending on each
    %control value. Number of control values is ns.
    %what to do with control values of multiple shooting?
    
     % Append sensitivity system
     ddx=[];
     %for all the controls and for all the stages
 for currc = 1:ModelData.numcontrols
    for is = 1:ModelData.currentns
        if is == ks
            uws = 1.;
        else
            uws = 0.;
        end
        %and now derivations:
        %curr=[x(3*is+2) + uws;
        %- uws;
        %x(1) * x(3*is+1) ];
    end
 end
 %there is also the control variable connected to numerical method -
 %mutiple shooting.
for (inumstates=1:(ModelData.numstates))
    for is = 1:(ModelData.currentns-1)
    end
end
%stick together.
 ddx = [ ddx;curr]

end


end

